import { EventEmitter, OnInit } from '@angular/core';
import { I18nService } from '../i18n/i18n.service';
import { CalendarHoliday } from './interfaces/calendar-holiday.interface';
export interface ObjectDateCalendar {
    day: number;
    month: number;
    year: number;
    fullDate: Date;
}
export declare class TlCalendar implements OnInit {
    private i18nService;
    date: Date;
    holidays: Array<CalendarHoliday>;
    width: string;
    todayButton: boolean;
    borders: boolean;
    height: string;
    selectDay: EventEmitter<ObjectDateCalendar>;
    today: EventEmitter<ObjectDateCalendar>;
    doubleClick: EventEmitter<any>;
    selectedPanel: 'days' | 'months' | 'years';
    currentRange: any;
    todayDescription: string;
    dayOfWeek: String[];
    constructor(i18nService: I18nService);
    ngOnInit(): void;
    get typeNavigator(): "year" | "monthyear" | "rangeyear";
    onSelectMonth($event: any): void;
    onClickNavigator($event: any): void;
    getObjectDate(): {
        day: number;
        month: number;
        year: number;
        fullDate: Date;
    };
    clickToday(): void;
    onSelectDay($event: any): void;
    onSelectYear($event: any): void;
    onClickPrevious($event: any): void;
    onClickNext($event: any): void;
}
