import { AfterViewInit, EventEmitter, OnInit, ElementRef, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { FormControl } from '@angular/forms';
import { ChatContact } from '../interfaces/chat-contact.interface';
import { ChatStatus } from '../interfaces/chat-status.interface';
import { DatePipe } from '@angular/common';
import { I18nService } from '../../i18n/i18n.service';
import { ChatService } from '../services/chat.service';
export declare class TlChatContent implements AfterViewInit, OnInit, OnDestroy {
    private i18nService;
    private change;
    private chatService;
    id: string;
    maxHeight: string;
    partner: ChatContact;
    user: ChatContact;
    loadingMessages: boolean;
    chatStatus: ChatStatus;
    readMessage: EventEmitter<any>;
    message: EventEmitter<{
        value: string;
        time: Date;
    }>;
    input: ElementRef;
    messageContent: ElementRef;
    messages: any[];
    smoothScroll: boolean;
    private opened;
    control: FormControl;
    datePipe: DatePipe;
    saySomething: string;
    loadingMessagesLabel: string;
    private subscription;
    private today;
    private yesterday;
    constructor(i18nService: I18nService, change: ChangeDetectorRef, chatService: ChatService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    listenAppendMessage(): void;
    listenChangeMessages(): void;
    filterMessages(collection: any): any;
    currentDate(date: any): string;
    getDate(date?: Date): number;
    trackByFn(index: any): any;
    setScrollBottom(): void;
    setInputFocus(): void;
    sendMessage(): void;
    ngOnDestroy(): void;
}
