import { ChatMessage } from '../interfaces/chat-message.interface';
import { Status } from '../enums/status.enum';
import { Subject } from 'rxjs';
import { ChatContact } from '../interfaces/chat-contact.interface';
export declare class ChatService {
    private chatObject;
    appendAndRead: Subject<unknown>;
    changeStatus: Subject<unknown>;
    allMessages: Subject<unknown>;
    newMessages: Subject<unknown>;
    unreadMessages: Subject<unknown>;
    constructor();
    loadMessages(messages: ChatMessage[], chatId: string, user: ChatContact): void;
    appendMessage(message: ChatMessage, user: ChatContact, chatId: string): void;
    readMessages(messages: ChatMessage[], user: ChatContact, chatId: string): void;
    readAll(chatId: string): void;
    setStatus(status: Status, chatId: string): void;
    getAllMessages(chatId: string): any;
    deleteChat(chatId: string): void;
    getUnreadMessages(messages: any, user: ChatContact): any;
    private isMessagesToUser;
    private existChat;
    private hasMessages;
    private getFirstChat;
}
