import { EventEmitter, Renderer2, AfterContentInit, OnDestroy, AfterViewInit } from '@angular/core';
import { NgModel } from '@angular/forms';
import { ElementBase } from '../input/core/element-base';
import { ClockPickerService } from './services/clockpicker.service';
export declare class TlClockPicker extends ElementBase<string> implements AfterViewInit, AfterContentInit, OnDestroy {
    private renderer;
    label: string;
    name: string;
    labelSize: string;
    textAlign: string;
    labelPlacement: string;
    readonly: boolean;
    disabled: boolean;
    placeholder: string;
    clearButton: boolean;
    autoClose: boolean;
    iconTimepicker: boolean;
    showButtonDone: boolean;
    buttonDoneMessage: string;
    color: string;
    changeTime: EventEmitter<any>;
    model: NgModel;
    tlinput: any;
    timePickerContent: any;
    uiClockRadius: any;
    wrapperDialMin: any;
    wrapperDial: any;
    iconAfter: string;
    moving: boolean;
    time: {
        hour: string;
        minute: string;
    };
    timepickerService: ClockPickerService;
    isClockPickerAbove: boolean;
    private listeners;
    private clockMeasure;
    private wrapperMeasure;
    private boxCenter;
    constructor(validators: Array<any>, asyncValidators: Array<any>, renderer: Renderer2);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    handleIconClockPicker(): void;
    setPickerMeasures(): void;
    setClockOffset(): void;
    setWrapperOffset(): void;
    setBoxCenter(): void;
    handleModelChange(): void;
    listenDocumentScroll(): void;
    windowMouseMove(): void;
    documentMouseDown(): void;
    isElementInPath($event: any): void;
    setInputValue(value: any): void;
    close(): void;
    opened(): boolean;
    changeHour(): void;
    changeMinute(): void;
    onCloseClockPicker(): void;
    onKeyUp($event: any): void;
    clearMask(value: any): any;
    open(): void;
    onMouseDown(): void;
    onMouseUp(): void;
    handleClockPickerPosition(): void;
    setTopPositionTop(): void;
    setWrapperClockPickerPositionBottom(): void;
    setTopPositionBottom(): void;
    setLeftPosition(): void;
    isHourDial(): boolean;
    onClearInput($event: any): void;
    ngOnDestroy(): void;
}
