import { AfterContentInit, ChangeDetectorRef, EventEmitter, OnInit, Renderer2 } from '@angular/core';
import { CdkConnectedOverlay, ConnectedOverlayPositionChange } from '@angular/cdk/overlay';
import { ColorPickerService } from './services/colorpicker-service';
import { ValueAccessorBase } from '../input/core/value-accessor';
import { FormControlName, NgModel } from '@angular/forms';
export declare class TlColorPicker extends ValueAccessorBase<string> implements OnInit, AfterContentInit {
    private renderer;
    private change;
    private colorPickerService;
    label: string;
    labelSize: string;
    name: string;
    textAlign: string;
    labelPlacement: string;
    readonly: boolean;
    disabled: boolean;
    placeholder: string;
    mode: 'inline' | 'onlyColor' | 'fromOrigin' | 'input';
    recentColors: boolean;
    returnFormatColor: boolean;
    copyButton: boolean;
    openFocus: boolean;
    elementOrigin: any;
    color: string;
    model: NgModel;
    controlName: FormControlName;
    selectColor: EventEmitter<string>;
    tlinput: any;
    tlbutton: any;
    trigger: any;
    connectedOverlay: CdkConnectedOverlay;
    isOpen: boolean;
    saved: boolean;
    positionOverlay: string;
    required: boolean;
    private interval;
    constructor(renderer: Renderer2, change: ChangeDetectorRef, colorPickerService: ColorPickerService);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    listClickElementOrgin(): void;
    onPositionChange($event: ConnectedOverlayPositionChange): void;
    emitSelectColor($event: any): void;
    copyInputColor(inputElement: any): void;
    showCopyMessage(): void;
    keyDown($event: any): void;
    closeColorPicker(): void;
    validFromOrigin(): void;
}
