import { AfterContentInit, ElementRef, EventEmitter, OnChanges, OnInit, Renderer2, SimpleChanges, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { ColorPickerService } from '../../services/colorpicker-service';
import { ColorPickerHelpers } from '../../helpers/colorpicker-helpers';
export declare class TlColorPickerContent implements OnInit, AfterContentInit, OnChanges {
    private renderer;
    private colorPickerService;
    private colorPickerHelpers;
    overlayPosition: string;
    selectedColor: string;
    recentColors: boolean;
    returnFormatColor: boolean;
    color: string;
    selectColor: EventEmitter<any>;
    template: TemplateRef<any>;
    content: ElementRef;
    scheme: ElementRef;
    cursorScheme: ElementRef;
    hue: ElementRef;
    hueSlider: ElementRef;
    alpha: ElementRef;
    alphaSlider: ElementRef;
    positionSchemeX: number;
    positionSchemeY: number;
    contextScheme: any;
    contextHueSlider: any;
    contextAlphaSlider: any;
    private isMoving;
    presetColors: string[];
    constructor(renderer: Renderer2, colorPickerService: ColorPickerService, colorPickerHelpers: ColorPickerHelpers);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    windowMouseEvent(): void;
    getPositionSchemeX(): number;
    getPositionSchemeY(): number;
    setPositionScheme($event: any): Observable<number>;
    getPositionHue(): number;
    setPositionHue($event: any): Observable<number>;
    getPositionAlpha(): number;
    setPositionAlpha($event: any): Observable<number>;
    onMouseDownScheme($event: any): void;
    onMouseMoveScheme($event: any): void;
    onMouseDownHue($event: any): void;
    onMouseMoveHue($event: any): void;
    onMouseDownAlpha($event: any): void;
    onMouseMoveAlpha($event: any): void;
    getOpacityColor(): number;
    setOpacityColor(opacity: any): Observable<number>;
    getRgbaColor(): string;
    setRgbaColor(color: any): Observable<string>;
    getRgbaColorPreview(): string;
    setRgbaColorPreview(color: any): Observable<string>;
    createCanvasScheme(): void;
    deleteCanvasScheme(): void;
    fillGradient(): void;
    createCanvasHue(): void;
    deleteCanvasHue(): void;
    createCanvasAlpha(color: any): void;
    deleteCanvasAlpha(): void;
    opacityGradient(color: any): void;
    changeColorScheme(x: any, y: any): void;
    changeColor(x: any): void;
    changeOpacity(x: any): void;
    setColor(imageData: any): void;
    getPresetColor(): void;
    setPresetColor(color: any): Observable<string[]>;
    changeColorByPreset(color: any): void;
    updateColor(value: any): void;
    ngOnChanges(value: SimpleChanges): void;
}
