import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { TlDatatableRow } from '../row/datatable-row';
import { Observable } from 'rxjs';
import { DataSource } from '@angular/cdk/collections';
import { CdkVirtualScrollViewport } from '@angular/cdk/scrolling';
import { TlDatatableColumn } from '../column/datatable-column';
import { I18nService } from '../../../i18n/i18n.service';
import { ContextMenuService } from '../../../contextmenu/services/contextmenu.service';
import { ContextMenuInterface } from '../../../contextmenu/interfaces/context-menu.interface';
import { TlDatatableFilterService } from '../../services/datatable-filter.service';
export declare class TlDatatableContent implements AfterViewInit, OnDestroy {
    private i18n;
    private datatableFilterService;
    private changes;
    private contextMenuService;
    dataSource: Array<any> | Observable<Array<any>> | DataSource<any>;
    data: Array<any>;
    rowHeight: number;
    heightViewPort: number;
    columns: Array<TlDatatableColumn>;
    contextMenuItems: ContextMenuInterface[];
    rowClick: EventEmitter<any>;
    rowDbClick: EventEmitter<any>;
    rowSelect: EventEmitter<any>;
    viewport: CdkVirtualScrollViewport;
    items: QueryList<TlDatatableRow>;
    datableContent: ElementRef;
    private keyManager;
    private subscription;
    constructor(i18n: I18nService, datatableFilterService: TlDatatableFilterService, changes: ChangeDetectorRef, contextMenuService: ContextMenuService);
    ngAfterViewInit(): void;
    onRowClick(rowItem: TlDatatableRow, row: any, index: any): void;
    contextmenu($event: any, rowItem: TlDatatableRow, row: any, index: any): boolean;
    setContentFocus(): void;
    isEmpty(): boolean;
    emptyText(): string;
    mouseDown($event: any): void;
    mouseUp($event: any): void;
    onKeydown(event: any): void;
    onKeyup(): void;
    setFirstItemSelected(): void;
    setSelectedItem(): void;
    ngOnDestroy(): void;
}
