import { ComponentFactoryResolver } from '@angular/core';
import { ModalService } from '../modal/services/modal.service';
import { ConfirmationOptions } from './dialog-confirmation/confirmation-options';
import { ErrorOptions } from './dialog-error/error-options';
import { AlertOptions } from './dialog-alert/alert-options';
import { InfoOptions } from './dialog-info/info-options';
import { ModalOptions } from '../modal/interfaces/modal-options';
export interface ConfirmCallback {
    isYes?: any;
    isNo?: any;
}
export declare class DialogService {
    private modalService;
    private factoryResolver;
    constructor(modalService: ModalService, factoryResolver: ComponentFactoryResolver);
    info(message: string, options?: InfoOptions, mdOptions?: ModalOptions): Promise<unknown>;
    alert(message: string, options?: AlertOptions, mdOptions?: ModalOptions): Promise<unknown>;
    error(message: string, options?: ErrorOptions, mdOptions?: ModalOptions): Promise<unknown>;
    confirmation(message: string, callbackConfirmation: ConfirmCallback, options?: ConfirmationOptions, mdOptions?: ModalOptions): void;
    private setDialogOptions;
}
