import { OnDestroy, Renderer2, OnChanges, SimpleChanges, AfterContentInit, ViewContainerRef } from '@angular/core';
import { Router } from '@angular/router';
import { SubMenuService } from './services/submenu.service';
export declare class TlMenu implements AfterContentInit, OnChanges, OnDestroy {
    private renderer;
    private router;
    private subMenuService;
    private viewRoot;
    items: any[];
    label: string;
    icon: string;
    subItem: string;
    dockWidth: string;
    width: string;
    docked: boolean;
    charsToSearch: number;
    group: string;
    filterEmptyMessage: string;
    maxHeight: string;
    itemHeight: string;
    topDislocation: number;
    widthRootMenu: string;
    outsideBorder: boolean;
    inputPlaceholder: string;
    titleMenu: string;
    operationMode: 'click' | 'hover';
    mode: 'simple' | 'advanced';
    link: string;
    menuList: ViewContainerRef;
    private listElement;
    private iconElement;
    private labelElement;
    private iconSubElement;
    private elements;
    private indexSubMenu;
    private callBack;
    private subscription;
    constructor(renderer: Renderer2, router: Router, subMenuService: SubMenuService, viewRoot: ViewContainerRef);
    ngAfterContentInit(): void;
    listenRouteChange(): void;
    createList(): void;
    addRootClass(): void;
    handleDockedClass(): void;
    initializeMenu(): void;
    handleAlwaysActive(value: any): void;
    handleSubItems(item: any): void;
    handleListenerSubMenu(item: any): void;
    createElementList(item: any): void;
    listenDocumentClick(): void;
    isRouterActive(item: any): boolean;
    listenClickElementList(item: any): void;
    setStyleListElement(): void;
    createElementIcon(icon: any): void;
    createElementIconSubMenu(subItem: any): void;
    listenWindowResize(): void;
    listenClickListElement(): void;
    handleVisibilitySubMenu(): void;
    isTargetOnListElement($event: any): boolean;
    createElementLabel(label: any): void;
    isDocked(): any;
    orderElements(): void;
    insertListElementToList(): void;
    resetList(): void;
    ngOnChanges(changes: SimpleChanges): void;
    handleChangeDocked(changes: any): void;
    handleChangeItems(changes: any): void;
    handleChangeMode(changes: any): void;
    ngOnDestroy(): void;
}
