import { AfterViewInit, ChangeDetectorRef, ComponentRef, ElementRef, EventEmitter, NgZone, OnDestroy, OnInit, Renderer2, ViewContainerRef } from '@angular/core';
import { ContainerModalService } from './addons/container-modal/container-modal.service';
import { ModalService } from './services/modal.service';
import { ModalOptions } from './interfaces/modal-options';
import { SidebarService } from './services/sidebar.service';
import { Subscription } from 'rxjs';
export declare class TlModal implements OnInit, AfterViewInit, ModalOptions, OnDestroy {
    private element;
    private renderer;
    private containerService;
    private sidebarService;
    private zone;
    private change;
    draggable: boolean;
    minimizable: boolean;
    maximizable: boolean;
    closable: boolean;
    icon: string;
    title: string;
    color: string;
    height: string;
    closeOnOK: boolean;
    width: string;
    fullscreen: boolean;
    restoreMaximize: boolean;
    backdrop: boolean;
    translucent: boolean;
    closeShortcut: string;
    restoreShortcut: string;
    maximizeShortcut: string;
    showTitlebar: boolean;
    parentElement: any;
    headerBox: ElementRef;
    modal: ElementRef;
    body: ViewContainerRef;
    show: EventEmitter<any>;
    minimize: EventEmitter<any>;
    maximize: EventEmitter<any>;
    close: EventEmitter<any>;
    componentRef: ComponentRef<TlModal>;
    id: string;
    subscription: Subscription;
    status: string;
    index: any;
    serviceControl: ModalService;
    maximized: boolean;
    private mousePressX;
    private mousePressY;
    private positionMouseMoveX;
    private positionMouseMoveY;
    private moving;
    private offsetLeftContent;
    private offsetTopContent;
    private offsetLeftModal;
    private offsetTopModal;
    private parent;
    private modalLeft;
    private modalTop;
    private positionX;
    private positionY;
    private subscribeResize;
    constructor(element: ElementRef, renderer: Renderer2, containerService: ContainerModalService, sidebarService: SidebarService, zone: NgZone, change: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    listenSidebarChange(): void;
    handleChangeSidebarWhenMaximized(): void;
    handleInitialPositionModal(): void;
    handleFullscreen(): void;
    resizeListener(): void;
    addTransitionModal(): void;
    mousemoveListener(): void;
    mouseupListener(): void;
    removeTransitionModal(): void;
    mouseDown($event: any): void;
    validateProperty(): void;
    validateMeasureParentAndModal(): void;
    getModalPosition(): void;
    setModalCenterParent(): void;
    setModalCenterWindow(): void;
    setComponentRef(component: ComponentRef<TlModal>): void;
    setMousePressX(position: any): void;
    setMousePressY(position: any): void;
    setPosition(): void;
    setLeftPosition(): string | void;
    setTopPosition(): string | void;
    setOptions(options: ModalOptions): void;
    setIdentifier(id: string): void;
    setParentElement(parentElement: HTMLElement): void;
    setLeftLimitOfArea(): string;
    setTopLimitOfArea(): string;
    setOffsetLeftModal(offset: any): void;
    setOffsetTopModal(offset: any): void;
    setContentTopPosition(): void;
    setContentLeftPosition(): void;
    setNewTopPosition(): void;
    setNewLeftPosition(): void;
    setServiceControl(service: any): void;
    setDefaultDimensions(): void;
    setCurrentPosition(): void;
    isMouseOutOfTheWindowLeft(event: any): boolean;
    setActive(): void;
    getElementModal(): ElementRef<any>;
    isMouseOutOfTheWindowRight(event: any): boolean;
    isOutOfWindowOnLeft(): boolean;
    isOutOfWindowOnTop(): boolean;
    isOutOfWindowX(): boolean;
    isOutOfWindowY(): boolean;
    minimizeModal(): void;
    closeModal(): void;
    maximizeModal(): void;
    setModalLeftPosition(): void;
    setModalTopPosition(): void;
    setModalWidth(): void;
    setModalHeight(): void;
    getHeightOfWindow(): string;
    hasScroll(): boolean;
    restoreMaximizeModal(): void;
    getBoundingParentElement(): any;
    getBoundingContent(): void;
    ngOnDestroy(): void;
}
