import { OnDestroy } from '@angular/core';
import { ModalService } from '../modal/services/modal.service';
import { ShortcutConfig } from './shortcut.config';
export interface ElementShortcut {
    id: string;
    shortcut: string;
    element: any;
}
export declare class ShortcutService implements OnDestroy {
    private modalService;
    elementsListener: Array<ElementShortcut>;
    private renderer;
    private elementIndex;
    private currentShortcut;
    private highestZindexElement;
    private subscription;
    private activeModal;
    private config;
    private modalContextArray;
    constructor(modalService: ModalService);
    setConfig(config: ShortcutConfig): void;
    setRenderer(renderer: any): void;
    listenHeadingModal(): void;
    isKeyOnList(key: string): boolean;
    createListener(): void;
    isElementDisabledClass(): boolean;
    getElementDisabled(): any;
    handleClickComponentWithEqualsKeys(): void;
    handleClickComponentWithoutEqualsKeys(): void;
    handleEqualButton(): void;
    setModalContextArray(): void;
    handleEqualElement(): void;
    activeHighestButtonElement(): void;
    hasModalContextArray(): boolean;
    getModalContextEqualActiveModal(): any[];
    getExistModalContext(): ElementShortcut[];
    getButtonsOfCurrentShortCut(): ElementShortcut[];
    sortButtons(): ElementShortcut[];
    activeElementButton(element: any): void;
    filterButtons(): void;
    isKeysShortcutEqualsKeysEvent($event: KeyboardEvent): ElementShortcut;
    handleElementsOfView(): void;
    handleElementButton(item: any): void;
    handleOtherElements(item: any): void;
    isElementInstanceOfButton(value: any): boolean;
    handleShortcutMultipleKey(element: any): {
        ctrlKey: boolean;
        shiftKey: boolean;
        altKey: boolean;
        key: string;
    };
    getShortcutEventMultipleKey($event: KeyboardEvent): {
        ctrlKey: boolean;
        shiftKey: boolean;
        altKey: boolean;
        key: string;
    };
    existElementOnView(value: any): boolean;
    getCharsOfShortcut(element: any): string[];
    getShortcutWithoutSpaces(element: any): string;
    removeSpacesShortcutString(element: any): string[];
    deleteElementFromArray(element: any): void;
    deleteButtonElementFromArray(element: any): void;
    isButtonDisabled(): any;
    getEqualKeys(shortcut: any): ElementShortcut[];
    orderElementsByZindex(): void;
    filterElementsNotEqualButton(): ElementShortcut[];
    ngOnDestroy(): void;
}
