import { EventEmitter, OnChanges, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { LightboxService } from '../lightbox/services/lightbox.service';
import { ThumbnailService } from './thumbnail.service';
import { DialogService } from '../dialog/dialog.service';
import { ModalOptions } from '../modal/interfaces/modal-options';
export declare class TlThumbnail implements OnInit, OnChanges {
    private lightboxService;
    private thumbnailService;
    private dialogService;
    image: any;
    mimeType: any;
    data: {
        index?: number;
        description?: string;
        file: string;
        type: string;
    }[];
    bordered: boolean;
    shape: 'square' | 'circle';
    size: {
        width: string;
        height: string;
    };
    showDeleteButton: boolean;
    confirmationDeleteMessage: string;
    showConfirmationOnDelete: boolean;
    modalDeleteOptions: ModalOptions;
    overlayTemplate: TemplateRef<any>;
    emptyTemplate: TemplateRef<any>;
    clickThumbnail: EventEmitter<any>;
    clickDeleteThumbail: EventEmitter<any>;
    constructor(lightboxService: LightboxService, thumbnailService: ThumbnailService, dialogService: DialogService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    get isCircle(): boolean;
    onViewImage(image: any): void;
    onDeleteThumb(image: any): void;
}
